#if !defined(__BASE_T_H__)
#define __BASE_T_H__

#include <string>
#include <sstream>

#define BASE_T_BUG 1		// this is the code that should work
#define BASE_T_WORKS1 0
#define BASE_T_WORKS2 0
#define BASE_T_WORKS3 0


class base_data_t
{
public:
#if BASE_T_BUG == 1
	// ctor in lib and two names causes crash
	base_data_t();
	std::string name, value;
#endif

// any of the following runs without crash (in lib)
#if BASE_T_WORKS1 == 1
	base_data_t();
	std::string value;;
#endif

#if BASE_T_WORKS2 == 1
	std::string name, value;
#endif

#if BASE_T_WORKS3 == 1
	base_data_t() {}
	std::string name, value;
#endif
};

class base_t
{
private:
	std::string theFN;
	unsigned numDecimals;
public:
	base_t(const std::string& fn = "", const unsigned nDec = 2);
	virtual ~base_t();

	bool setBody(const std::string& name, std::ostringstream& s)
	{
		base_data_t ce;
#if BASE_T_WORKS1 == 0
		ce.name = name;
#endif
		ce.value = s.str();
		return true;
	}

	template <typename T>
	bool set(const std::string& name, const T& value)
	{
		std::ostringstream s;

		s << value;
		return setBody(name, s);
	}
};

template<> bool base_t::set(const std::string& name, const float& value);

#endif
