static char rcsid[] =
"$Id: ";

#include <string>

#include "base_t.h"		// pulling the base class code into this file
				// works fine also

typedef struct
{
	float f;
	unsigned u;
} derived_data_t;

class derived_t : public base_t
{
private:
	static const std::string fstr;
	static const std::string ustr;

public:

	derived_t(const std::string& path);
	~derived_t();

	derived_data_t data;
};



// #define DERIVED_BUG_ORDER 0		// works as expected
#define DERIVED_BUG_ORDER 1		// dumps core w/ BASE_T_BUG == 1

using namespace std;

const string derived_t::fstr = "f";
const string derived_t::ustr = "u";

derived_t::derived_t(const string& path) : base_t(path)
{
#if DERIVED_BUG_ORDER == 1
	data.u = 100;
	set(ustr, data.u);

	data.f = 100.0;
/*->*/	set(fstr, data.f);
#else
	// using floating point (specialization) first gives no error
	data.f = 100.0;
/*->*/	set(fstr, data.f);

	data.u = 100;
	set(ustr, data.u);
#endif
}

derived_t::~derived_t()
{
	(void)rcsid;
}

#include <iostream>
#include <iomanip>

string file("AS.config");
string dir(".");

int main(int argc, char **argv)
{
	string s(dir + "/" + file);
	derived_t config(s);

	cout << setiosflags(ios::fixed | ios::showpoint) << setprecision(2);

	cout << "f:" << config.data.f
	     << "  u:" << config.data.u << '\n';

	return 0;
}
